//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "IMG.h"
#include "BMP.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TImagenBMP *ImagenBMP;
//---------------------------------------------------------------------------
__fastcall TImagenBMP::TImagenBMP(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::FormCreate(TObject *Sender)
{
  Actual   = NULL;
  Anterior = NULL;

  Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::FormDestroy(TObject *Sender)
{
  if (Actual)
     DestruyeImagen(&Actual);

  if (Anterior)
     DestruyeImagen(&Anterior);
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::FormResize(TObject *Sender)
{
  if (  ( Actual )
     && ( ImagenBMP->Width < ClientWidth )
     && ( ImagenBMP->Height < ClientHeight ) ) {

     ImagenBMP->Top  = (ClientHeight - ImagenBMP->Height ) / 2;
     ImagenBMP->Left = (ClientWidth  - ImagenBMP->Width  ) / 2;

  } else {

     ImagenBMP->Top  = 0;
     ImagenBMP->Left = 0;
  }

  ImagenBMP->Repaint();
}
//---------------------------------------------------------------------------
int __fastcall TImagenBMP::Color (void)
{
  if (PaletaImagen(Actual))
     return 1;
  else
     return 0;
}
//---------------------------------------------------------------------------
int __fastcall TImagenBMP::OK (void)
{
  if (Actual)
     return 1;
  else
     return 0;
}
//---------------------------------------------------------------------------
int __fastcall TImagenBMP::AnteriorOK (void)
{
  if (Anterior)
     return 1;
  else
     return 0;
}
//---------------------------------------------------------------------------
Graphics::TBitmap *__fastcall TImagenBMP::Bitmap (void)
{
  return ImagenBMP->Picture->Bitmap;
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::ActualizarMensaje (void)
{
  switch (zoom) {
    case -4: Caption = "x/16";
             break;
    case -3: Caption = "x/8";
             break;
    case -2: Caption = "x/4";
             break;
    case -1: Caption = "x/2";
             break;
    case  0: Caption = "";
             break;
    case  1: Caption = "2x";
             break;
    case  2: Caption = "4x";
             break;
    case  3: Caption = "8x";
             break;
    case  4: Caption = "16x";
             break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::Nueva (Imagen img)
{
  char nombre[] = "tmp.bmp";
  int  dim;

  if (img) {

     if ((Actual) && (Actual!=img)) {

        if ((Anterior) && (Anterior!=img))
           DestruyeImagen(&Anterior);

        Anterior = Actual;
     }

     Actual = img;

     GuardaBMP (Actual,nombre);
     ImagenBMP->Picture->LoadFromFile (nombre);
     remove (nombre);

     // Visualizacin

     dim = zoom;
     ImagenBMP->Height = ImagenBMP->Picture->Height;
     ImagenBMP->Width  = ImagenBMP->Picture->Width;

     if (dim>0) {

         while (dim>0) {
               ImagenBMP->Height *= 2;
               ImagenBMP->Width  *= 2;
               dim--;
         }

     } else {

         while (dim<0) {
               ImagenBMP->Height /= 2;
               ImagenBMP->Width  /= 2;
               dim ++;
         }
     }

     if (  ( ImagenBMP->Width < ClientWidth )
        && ( ImagenBMP->Height < ClientHeight ) ) {

        ImagenBMP->Top  = (ClientHeight - ImagenBMP->Height ) / 2;
        ImagenBMP->Left = (ClientWidth  - ImagenBMP->Width  ) / 2;

     } else {

        ImagenBMP->Top  = 0;
        ImagenBMP->Left = 0;
     }

     ImagenBMP->Repaint();
     ActualizarMensaje();
  }

/* Accediendo al canvas  (muy lento)

  int                dim;
  int                anchura,altura;
  int                i,x,y;
  int                paleta[256];
  Graphics::TBitmap *BMP;

  if (img) {

     if ((Actual) && (Actual!=img)) {

        if ((BMPAnterior) && (Anterior!=img))
           DestruyeImagen(&Anterior);

        Anterior = Actual;
     }

     Actual = img;

     // Nuevo BITMAP

     anchura = ANCHURA(img);
     altura  = ALTURA(img);
     BMP     = ImagenBMP->Picture->Bitmap;

     BMP->Width  = anchura;
     BMP->Height = altura;

     if (img->Paleta) {

        for (i=0; i<256; i++)
            paleta[i] = (PALETA(img,i).R)
                      | (PALETA(img,i).G<<8)
                      | (PALETA(img,i).B<<16);
     } else {

        for (i=0; i<256; i++)
            paleta[i] = i|(i<<8)|(i<<16);
     }

     for (x=0; x<anchura; x++)
         for (y=0; y<altura; y++)
             BMP->Canvas->Pixels[x][y] = (TColor)paleta[PIXEL(img,x,y)];

     // Visualizacin

     dim = zoom;
     ImagenBMP->Height = ImagenBMP->Picture->Height;
     ImagenBMP->Width  = ImagenBMP->Picture->Width;

     if (dim>0) {

         while (dim>0) {
               ImagenBMP->Height *= 2;
               ImagenBMP->Width  *= 2;
               dim--;
         }

     } else {

         while (dim<0) {
               ImagenBMP->Height /= 2;
               ImagenBMP->Width  /= 2;
               dim ++;
         }
     }

     if (  ( ImagenBMP->Width < ClientWidth )
        && ( ImagenBMP->Height < ClientHeight ) ) {

        ImagenBMP->Top  = (ClientHeight - ImagenBMP->Height ) / 2;
        ImagenBMP->Left = (ClientWidth  - ImagenBMP->Width  ) / 2;

     } else {

        ImagenBMP->Top  = 0;
        ImagenBMP->Left = 0;
     }

     ImagenBMP->Repaint();
     ActualizarMensaje();
  }
*/
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::Previa (void)
{
  Nueva(Anterior);
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::Siguiente (void)
{
  Nueva(Anterior);
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::Acercar (void)
{
  if (zoom<4) {
     zoom++;
     ImagenBMP->Height*=2;
     ImagenBMP->Width*=2;

     if (  ( ImagenBMP->Width < ClientWidth )
        && ( ImagenBMP->Height < ClientHeight ) ) {

        ImagenBMP->Top  = (ClientHeight - ImagenBMP->Height ) / 2;
        ImagenBMP->Left = (ClientWidth  - ImagenBMP->Width  ) / 2;

     } else {

        ImagenBMP->Top  = 0;
        ImagenBMP->Left = 0;
     }

     ImagenBMP->Repaint();
     ActualizarMensaje();
  }
}
//---------------------------------------------------------------------------
void __fastcall TImagenBMP::Alejar (void)
{
  if (zoom>-4) {

     zoom --;
     ImagenBMP->Height /= 2;
     ImagenBMP->Width  /= 2;

     if (  ( ImagenBMP->Width < ClientWidth )
        && ( ImagenBMP->Height < ClientHeight ) ) {

        ImagenBMP->Top  = (ClientHeight - ImagenBMP->Height ) / 2;
        ImagenBMP->Left = (ClientWidth  - ImagenBMP->Width  ) / 2;

     } else {

        ImagenBMP->Top  = 0;
        ImagenBMP->Left = 0;
     }

     ImagenBMP->Repaint();
     ActualizarMensaje();
  }
}

