//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CONVOLVE.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma resource "*.dfm"
TFormConvolve *FormConvolve;
//---------------------------------------------------------------------------
__fastcall TFormConvolve::TFormConvolve(TComponent* Owner)
	: TForm(Owner)
{
  DimX = 5;
  DimY = 5;
  CentroX = 2;
  CentroY = 2;
}
//---------------------------------------------------------------------------
// Idioma
//---------------------------------------------------------------------------
#define SPANISH 0
#define ENGLISH 1

void __fastcall TFormConvolve::Idioma (int language)
{
  if (language==SPANISH) {
     Caption = "Convolucin";
     LabelFilas->Caption = "Filas";
     LabelColumnas->Caption = "Columnas";
     LabelCentro->Caption = "Centro de la mscara";
     BitBtnSpatial->Caption = "Convolucionar en el dominio espacial";
     BitBtnFrequency->Caption = "Convolucionar en el dominio frecuencial";
  } else if (language==ENGLISH) {
     Caption = "Convolution";
     LabelFilas->Caption = "Rows";
     LabelColumnas->Caption = "Columns";
     LabelCentro->Caption = "Mask Center";
     BitBtnSpatial->Caption = "Spatial domain convolution";
     BitBtnFrequency->Caption = "Frequency domain convolution";
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::LeerGrid (void)
{
  int  i,j;
  char s[10];

  for (i=0; i<DimX; i++)
      for (j=0; j<DimY; j++) {
          Mask->datos[i][j] = atof (StringGridMask->Cells[i][j].c_str());
      }
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::ActualizarGrid (void)
{
  int  i,j;
  char s[10];

  for (i=0; i<DimX; i++)
      for (j=0; j<DimY; j++) {
          sprintf (s,"%e",Mask->datos[i][j]);
          StringGridMask->Cells[i][j] = s;
      }
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::ScrollBarHChange(TObject *Sender)
{
  char s[10];

  DimY = StringGridMask->RowCount = ScrollBarH->Position;
  ScrollBarY->Max = DimY-1;
  sprintf (s,"%d",StringGridMask->RowCount);
  LabelH->Caption = s;
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::ScrollBarWChange(TObject *Sender)
{
  char s[10];

  DimX = StringGridMask->ColCount = ScrollBarW->Position;
  ScrollBarX->Max = DimX-1;
  sprintf (s,"%d",StringGridMask->ColCount);
  LabelW->Caption = s;
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::ScrollBarXChange(TObject *Sender)
{
  char s[10];

  CentroX = ScrollBarX->Position;
  sprintf (s,"%d",ScrollBarX->Position);
  LabelX->Caption = s;
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::ScrollBarYChange(TObject *Sender)
{
  char s[10];

  CentroY = ScrollBarY->Position;
  sprintf (s,"%d",ScrollBarY->Position);
  LabelY->Caption = s;
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::FormActivate(TObject *Sender)
{
  char s[10];
  int  i,j;

  StringGridMask->RowCount = ScrollBarH->Position = DimY;
  ScrollBarY->Max = DimY-1;
  sprintf (s,"%d",StringGridMask->RowCount);
  LabelH->Caption = s;

  StringGridMask->ColCount = ScrollBarW->Position = DimX;
  ScrollBarX->Max = DimX-1;
  sprintf (s,"%d",StringGridMask->ColCount);
  LabelW->Caption = s;

  ScrollBarX->Position = CentroX;
  sprintf (s,"%d",ScrollBarX->Position);
  LabelX->Caption = s;

  ScrollBarY->Position = CentroY;
  sprintf (s,"%d",ScrollBarY->Position);
  LabelY->Caption = s;

  if (Mask)
     DestruyeFloatImg (&Mask);

  Mask = CreaFloatImg(128,128);
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::BitBtnSpatialClick(TObject *Sender)
{
  LeerGrid();
  Tipo = 1;
}
//---------------------------------------------------------------------------
void __fastcall TFormConvolve::BitBtnFrequencyClick(TObject *Sender)
{
  LeerGrid();
  Tipo = 2;
}
//---------------------------------------------------------------------------
