/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                       Procesamiento de imgenes                         */
/* ----------------------------------------------------------------------- */
/*                              Convolucin                                */
/* ----------------------------------------------------------------------- */

#include "IMG_CONV.H"
#include "IMG_FREQ.H"

/* ----------------------------------------------------------------------- */

Imagen Convolve ( Imagen   img,
                  FloatImg mask, int dimX, int dimY, int centroX, int centroY)
{
  int      x,y,i,j;
  int      px,py;
  float    valor;
  WORD     anchura = ANCHURA(img);
  WORD     altura  = ALTURA(img);
  Imagen   salida  = CreaImagen(anchura,altura);

  for (x=0; x<anchura; x++)
      for (y=0; y<altura; y++) {

          valor = 0;

          for (i=0; i<dimX; i++)
              for (j=0; j<dimY; j++) {
                  px = (x+i-centroX+anchura)%anchura;
                  py = (y+j-centroY+altura)%altura;
                  valor += (mask->datos[i][j])*PIXEL(img,px,py);
              }

          if (valor>255)
             PIXEL(salida,x,y) = 255;
          else if (valor<0)
             PIXEL(salida,x,y) = 0;
          else
             PIXEL(salida,x,y) = (BYTE) valor;
      }

  return salida;
}

/* ----------------------------------------------------------------------- */

Imagen ConvolveTotal ( Imagen   img,
                       FloatImg mask, int dimX, int dimY, int centroX, int centroY)
{
  int      x,y,i,j;
  int      px,py;
  float    valor;
  WORD     anchura = ANCHURA(img);
  WORD     altura  = ALTURA(img);
  FloatImg aux     = CreaFloatImg(anchura,altura);
  Imagen   salida;

  for (x=0; x<anchura; x++)
      for (y=0; y<altura; y++) {

          valor = 0;

          for (i=0; i<dimX; i++)
              for (j=0; j<dimY; j++) {
                  px = (x+i-centroX+anchura)%anchura;
                  py = (y+j-centroY+altura)%altura;
                  valor += (mask->datos[i][j])*PIXEL(img,px,py);
              }

          aux->datos[x][y] = valor;
      }

  salida = ImagenFloat(aux);

  DestruyeFloatImg(&aux);

  return salida;
}


