/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                       Procesamiento de imgenes                         */
/* ----------------------------------------------------------------------- */
/*                        Transformada de Fourier                          */
/* ----------------------------------------------------------------------- */

#include "IMG.H"
#include "IMG_TYPE.H"

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*  2D Fast Fourier Transform                                              */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

ComplexImg FFTImagen (Imagen img);

ComplexImg OriginCenteredFFTImagen (Imagen img);

ComplexImg InverseFFTImagen (ComplexImg img);

ComplexImg InverseOriginCenteredFFTImagen (ComplexImg img);

/* ----------------------------------------------------------------------- */
/*  Adaptar imagen para que se le pueda aplicar la FFT (max 1024x1024)     */
/*   Imagen cuadrada de lado potencia de 2 (0 = ajuste automtico)        */

Imagen AdaptarImagenFFT (Imagen img, int dim);

Imagen ExtraerImagenFFT (Imagen img, WORD anchura, WORD altura);

/* ----------------------------------------------------------------------- */
/*  Devuelve una imagen de la FFT de la imagen 'img'                       */

Imagen ImagenFFT    (Imagen img);
Imagen ImagenLogFFT (Imagen img);

/* ----------------------------------------------------------------------- */
/* Devuelve una imagen de la FFT (origin-centered) de la imagen 'img'      */

Imagen ImagenOriginCenteredFFT    (Imagen img);
Imagen ImagenLogOriginCenteredFFT (Imagen img);

/* ----------------------------------------------------------------------- */
/* Reordena una imagen que ha sido sometida a la FFT                       */

Imagen Shuffle (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Filtros ideales                                                        */

Imagen LowPassFilter  (Imagen img, int r);
Imagen HighPassFilter (Imagen img, int r);
Imagen BandPassFilter (Imagen img, int r1, int r2);

/* ----------------------------------------------------------------------- */
/*  Filtros Butterworth                                                    */

Imagen ButterworthLowPass  (Imagen img, int d, int n);
Imagen ButterworthHighPass (Imagen img, int d, int n);

/* ----------------------------------------------------------------------- */
/*  Filtros exponenciales                                                  */

Imagen ExponentialLowPass  (Imagen img, int sup);
Imagen ExponentialHighPass (Imagen img, int inf);
Imagen ExponentialBandPass (Imagen img, int inf, int sup);

/* ----------------------------------------------------------------------- */
/*  Cross Section filter                                                   */

Imagen CrossSectionFilter (Imagen img, float *d, int Nd);

/* ----------------------------------------------------------------------- */
/*  Homomorphic filter                                                     */

Imagen HomomorphicFilter (Imagen img, float *d, int Nd);

/* -----------------------------------------------------------------------

Imagen FrequencyDomainFilter (Imagen img)
{
  Imagen     salida;
  ComplexImg fft1, fft2;

  if (ANCHURA(img)!=ALTURA(img))
     return NULL;

  fft1   = OriginCenteredFFTImagen (img);

  // Filter

  fft2   = InverseFFTImagen (fft1);
  salida = ImagenComplex (fft2);

  DestruyeComplexImg(fft1);
  DestruyeComplexImg(fft2);

  return salida;
}

  ----------------------------------------------------------------------- */



/* Convolucin */

Imagen FourierConvolve ( Imagen   img,
                         FloatImg mask, int dimX, int dimY, int centroX, int centroY);

