/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                       Procesamiento de imgenes                         */
/* ----------------------------------------------------------------------- */
/*                         Realzado de imgenes                            */
/* ----------------------------------------------------------------------- */

#include "IMG.H"

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

BYTE Rango (Imagen img, BYTE *min, BYTE *max);

BYTE MaxPixel (Imagen img);
BYTE MinPixel (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Negativar una imagen (GRAYLEVEL)                                       */
/* ----------------------------------------------------------------------- */

Imagen Negativar (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Aclarar una imagen (GRAYLEVEL)                                         */
/* ----------------------------------------------------------------------- */

Imagen Aclarar (Imagen img, BYTE n);

/* ----------------------------------------------------------------------- */
/*  Oscurecer una imagen (GRAYLEVEL)                                       */
/* ----------------------------------------------------------------------- */

Imagen Oscurecer (Imagen img, BYTE n);

/* ----------------------------------------------------------------------- */
/*  Contrastar una imagen (GRAYLEVEL)                                      */
/* ----------------------------------------------------------------------- */

Imagen Contrastar (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Ajuste del contraste: STRETCHING                                       */
/* ----------------------------------------------------------------------- */
/*  Polilnea: (0,0)(x,y)(u,v)(255,255)                                    */

Imagen Stretch (Imagen img, BYTE x, BYTE y, BYTE u, BYTE v);

/* ----------------------------------------------------------------------- */
/*  Ecualizacin del histograma (GRAYLEVEL)                                */
/* ----------------------------------------------------------------------- */

Imagen Equalization ( Imagen img );

/* ----------------------------------------------------------------------- */
/*  Logaritmo                                                              */
/* ----------------------------------------------------------------------- */

Imagen LogImagen (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Exponencial                                                            */
/* ----------------------------------------------------------------------- */

Imagen ExpImagen (Imagen img);

/* ----------------------------------------------------------------------- */
/*  GDA: Gradation Removal by averaging (GRAYLEVEL)                        */
/* ----------------------------------------------------------------------- */
/*  X_rec: 1..64                                                           */
/*  Y_rec: 1..64                                                           */

Imagen GDA (Imagen img, BYTE X_rec, BYTE Y_rec);

/* ----------------------------------------------------------------------- */
/*  Median Filter                                                          */
/* ----------------------------------------------------------------------- */

Imagen MedianFilter ( Imagen img );

/* ----------------------------------------------------------------------- */
/*  Modal Filter                                                           */
/* ----------------------------------------------------------------------- */

Imagen ModalFilter ( Imagen img );

/* ----------------------------------------------------------------------- */
/*  Averaging Filter                                                       */
/* ----------------------------------------------------------------------- */

Imagen AveragingFilter ( Imagen img );

/* ----------------------------------------------------------------------- */
/*  Closest Averaging                                                      */
/* ----------------------------------------------------------------------- */

Imagen ClosestAveragingFilter ( Imagen img );

/* ----------------------------------------------------------------------- */
/*  Gaussiana                                                              */
/* ----------------------------------------------------------------------- */
/*  s: Desviacin estndar de la gaussiana                                 */
/*  d: Tamao del filtro ---> Ventana (2d+1)*(2d+1)                        */

Imagen GaussianFilter ( Imagen img, float s, int d);

/* ----------------------------------------------------------------------- */
/*  Suavizado de imgenes                                                  */
/* ----------------------------------------------------------------------- */
/*  0<k<1: Factor de suavizado [suavizado mximo: k=1]                     */

Imagen Suavizado ( Imagen origen, float k);

/* ----------------------------------------------------------------------- */
/*  Afilado de imgenes                                                    */
/* ----------------------------------------------------------------------- */
/*  0<s<1 : Factor de suavizado [suavizado mximo: s=1]                    */
/*  0<k   : Factor de afilado                                              */

Imagen UnsharpMask (Imagen origen, float s, float k);

/* ----------------------------------------------------------------------- */
/*  0<k   : Factor de afilado                                              */

Imagen AfiladoLaplaciana ( Imagen origen, float k );

/* ----------------------------------------------------------------------- */
/*    w   : Ventana (2w+1)(2w+1)                                           */
/*  0<k   : Factor de afilado                                              */

Imagen AfiladoDV ( Imagen origen, BYTE w, float k );                /* AGC */

/* ----------------------------------------------------------------------- */
/*  GRADIENTE                                                              */

Imagen GradienteSqrt (Imagen img);
Imagen GradienteAbs  (Imagen img);

Imagen GradienteRobertsSqrt (Imagen img);
Imagen GradienteRobertsAbs  (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Suavizado mediante mscaras                                            */

Imagen SuavizadoPseudoAVG  (Imagen img);
Imagen SuavizadoMexicanHat (Imagen img);
Imagen SuavizadoSOFT       (Imagen img);

/* ----------------------------------------------------------------------- */
/*  Realzado mediante mscaras                                             */

Imagen Realzado4entorno   (Imagen img);
Imagen Realzado8entorno   (Imagen img);
Imagen RealzadoDistEuclid (Imagen img);

/* ----------------------------------------------------------------------- */
