/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                       Procesamiento de imgenes                         */
/* ----------------------------------------------------------------------- */

#include "IMG.H"

#ifndef __IMG_TYPE__
#define __IMG_TYPE__

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*  ComplexImg                                                             */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

typedef struct Complex  {
			  float real;
			  float imag;
			} Complex;

/* --- */

typedef struct InfoComplexImg {
		                WORD      anchura;
                                WORD      altura;
			        Complex **datos;
			      } InfoComplexImg;

typedef struct InfoComplexImg *ComplexImg;

/* ----------------------------------------------------------------------- */

void NormalizarComplexImg (ComplexImg x);

/* ----------------------------------------------------------------------- */

ComplexImg CreaComplexImg (Imagen im);

ComplexImg CreaComplex (int dimX, int dimY);

/* ----------------------------------------------------------------------- */

ComplexImg CopiaComplexImg (ComplexImg im);

/* ----------------------------------------------------------------------- */

void DestruyeComplexImg (ComplexImg *x);

/* ----------------------------------------------------------------------- */
/*  Conversin ComplexImg ---> Imagen                                         */
/* ----------------------------------------------------------------------- */

Imagen ImagenComplex    ( ComplexImg image, WORD anchura, WORD altura);
Imagen ImagenLogComplex ( ComplexImg image, WORD anchura, WORD altura);

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*  FloatImg                                                               */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

typedef struct InfoFloatImg {
		       	      WORD    anchura;
			      WORD    altura;
			      float **datos;
			    } InfoFloatImg;

typedef struct InfoFloatImg *FloatImg;

/* ----------------------------------------------------------------------- */

FloatImg CreaFloatImg (WORD anchura, WORD altura);

/* ----------------------------------------------------------------------- */

void DestruyeFloatImg (FloatImg *x);

/* ----------------------------------------------------------------------- */
/*  Conversin FloatImg ---> Imagen                                        */
/* ----------------------------------------------------------------------- */

Imagen     ImagenFloat ( FloatImg imagen);

/* ----------------------------------------------------------------------- */

#endif __IMG_TYPE__
