/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                       Procesamiento de imgenes                         */
/* ----------------------------------------------------------------------- */
/*                               Wavelets                                  */
/* ----------------------------------------------------------------------- */

#include "IMG.H"

/* ----------------------------------------------------------------------- */

typedef struct InfoWavelet {
		             int     n;
			     float **info;
		           } InfoWavelet;

typedef struct InfoWavelet *Wavelet;

/* ----------------------------------------------------------------------- */

Wavelet CreaWavelet     (int n);

void    DestruyeWavelet (Wavelet *wt);

Wavelet CopiaWavelet    (Wavelet wt);


void    ReduceWavelet   (Wavelet wt, int n);  /* Conserva NxN coeficientes */

/* ----------------------------------------------------------------------- */

Wavelet WaveletImagen        (Imagen img);

Imagen  ImagenWavelet        (Wavelet wt);
Imagen  ImagenLogWavelet     (Wavelet wt);

Imagen  ExtraerImagenWavelet (Wavelet wt, WORD anchura, WORD altura);

/* ----------------------------------------------------------------------- */
/*  2D wavelet transform, using Haar basis                                 */
/* ----------------------------------------------------------------------- */

void Haar        (Wavelet wt);

void InverseHaar (Wavelet wt);

/* --- */

Imagen ImagenHaar    (Imagen img);
Imagen ImagenLogHaar (Imagen img);

Imagen FiltradoHaar (Imagen img, int n);

/* ----------------------------------------------------------------------- */
/*  2D wavelet transform, using Daubechies basis (4 coefficients)          */
/* ----------------------------------------------------------------------- */

void Daubechies        (Wavelet wt);

void InverseDaubechies (Wavelet wt);

/* --- */

Imagen ImagenDaubechies    (Imagen img);
Imagen ImagenLogDaubechies (Imagen img);

Imagen FiltradoDaubechies (Imagen img, int n);

/* ----------------------------------------------------------------------- */
/*  2D Walsh transform                                                     */
/* ----------------------------------------------------------------------- */

void Walsh        (Wavelet wt);

void InverseWalsh (Wavelet wt);

/* --- */

Imagen ImagenWalsh    (Imagen img);
Imagen ImagenLogWalsh (Imagen img);

Imagen FiltradoWalsh (Imagen img, int n);

/* ----------------------------------------------------------------------- */
