//---------------------------------------------------------------------------

#include <vcl\vcl.h>
#pragma hdrstop

#include <vcl\printers.hpp>

#include "IMG.H"
#include "IMG_2D.H"
#include "IMG_CONV.H"
#include "IMG_EDGE.H"
#include "IMG_FREQ.H"
#include "IMG_GRAD.H"
#include "IMG_LINE.H"
#include "IMG_MORF.H"
#include "IMG_PROC.H"
#include "IMG_RGB.H"
#include "IMG_SEGM.H"
#include "IMG_SNR.H"
#include "IMG_WAVE.H"

#include "ABOUT.H"
#include "ANGULO.H"
#include "BANDA.H"
#include "BMP.H"
#include "BUTTERWORTH.H"
#include "CONVOLUTION.H"
#include "CONVOLVE.H"
#include "CUTOFF.H"
#include "GAUSS.H"
#include "GRIS.H"
#include "HISTOGRAMA.H"
#include "INFO.H"
#include "ITERACIONES.H"
#include "MEDIA.H"
#include "OPTIONS.H"
#include "PORCENTAJE.H"
#include "PRINT.H"
#include "RECORTE.H"
#include "SD.H"
#include "SECTION.H"
#include "SHARPENING.H"
#include "SMOOTHING.H"
#include "STRETCH.H"
#include "WAVELET.H"
#include "ZOOM.H"

#include "Main.h"

//---------------------------------------------------------------------------

#pragma resource "*.dfm"
TFormMain *FormMain;

//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Form
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormCreate(TObject *Sender)
{
  // Estado inicial de los mens

  MenuGuardarImagen->Enabled = false;
  MenuImprimir->Enabled      = false;
  MenuInformacion->Enabled   = false;

  MenuObtener->Visible       = false;
  MenuEdicion->Visible       = false;
  MenuProcesamiento->Visible = false;
}
//---------------------------------------------------------------------------
// Idioma
//---------------------------------------------------------------------------
void __fastcall TFormMain::Idioma (int language)
{
  if (language==SPANISH) {

     Caption = "Procesamiento de imgenes";

     // Imagen

     MenuImagen->Caption = "&Imagen";
     MenuCargarImagen->Caption = "&Cargar...";
     MenuGuardarImagen->Caption = "&Guardar...";
     MenuImprimir->Caption = "&Imprimir...";
     MenuAbout->Caption = "Acerca de...";
     MenuInformacion->Caption = "Informacin";
     MenuDimensiones->Caption = "Dimensiones";
     MenuHistograma->Caption = "Histograma";
     MenuHistogramaAcumulado->Caption = "Histograma acumulado";
     MenuOpciones->Caption = "&Opciones...";
     MenuSalir->Caption = "&Salir";

     // Edicin

     MenuEdicion->Caption = "&Edicin";
     MenuDeshacer->Caption = "Deshacer";
     MenuRehacer->Caption = "Rehacer";
     MenuAcercar->Caption = "Acercar";
     MenuAlejar->Caption = "Alejar";
     MenuReflejoHorizontal->Caption = "Reflejo horizontal";
     MenuReflejoVertical->Caption = "Reflejo vertical";
     MenuRotacion->Caption = "Rotacin...";
     MenuEscala->Caption = "Escala...";
     MenuZoomInterpolacion->Caption = "Zoom por interpolacin";
     MenuRecorte->Caption = "Recorte...";

     // Obtener

     MenuObtener->Caption = "&Obtener";
     MenuImagenNivelesDeGris->Caption = "Imagen en niveles de gris";
     MenuLuminanciaCIE->Caption = "Luminancia CIE";
     MenuLuminanciaNTSC->Caption = "Luminancia NTSC";
     MenuMediaRGB->Caption = "Media RGB";
     MenuMaximoRGB->Caption = "Mximo RGB";
     MenuMinimoRGB->Caption = "Mnimo RGB";
     MenuBandaR->Caption = "Banda R";
     MenuBandaG->Caption = "Banda G";
     MenuBandaB->Caption = "Banda B";

     // Procesamiento

     MenuProcesamiento->Caption = "&Procesamiento";

     MenuHistogramModification->Caption = "Modificacin del histograma";
     MenuExponencial->Caption = "Exponencial";
     MenuLogaritmo->Caption = "Logaritmo";
     MenuNegativar->Caption = "Negativar";
     MenuAclarar->Caption = "Aclarar...";
     MenuOscurecer->Caption = "Oscurecer...";
     MenuEcualizacion->Caption = "Ecualizar";
     MenuContrastar->Caption = "Contrastar";
     MenuStretching->Caption = "Extensin del contraste...";

     MenuConvolution->Caption = "Convolucin...";
     MenuConvolution3x3->Caption = "Convolucin 3x3...";

     // Morfologa

     MenuMorphology->Caption = "Morfologa";
     MenuMErosion->Caption = "Erosin";
     MenuMDilation->Caption = "Dilatacin";
     MenuMOpen->Caption = "Apertura";
     MenuMClose->Caption = "Clausura";
     MenuMGradient->Caption = "Gradiente";
     MenuMSmooth->Caption = "Suavizado";
     MenuMOutlining->Caption = "Contorno";

     // Segmentacin

     MenuSegmentation->Caption = "Segmentacin";
     MenuThreshold->Caption = "Umbralizacin...";

     MenuThresholdingMethods->Caption = "Umbralizacin automtica";
     MenuHysteresisThresholding->Caption = "Histresis...";
     MenuTMMean->Caption = "Media";
     MenuTMBlackPercentage->Caption = "Porcentaje...";
     MenuTMTwoPeaks->Caption = "Mximos";
     MenuTMLaplacian->Caption = "Laplaciana...";
     MenuTMIterativeSelection->Caption = "Seleccin iterativa";
     MenuTMFuzzyEntropy->Caption = "Fuzzy: Entropa";
     MenuTMMinimumError->Caption = "Error mnimo";
     MenuTMRelaxation->Caption = "Relajacin";

     MenuTextureSegmentation->Caption = "Texturas";
     MenuTSAverage->Caption = "Media";
     MenuTSStandardDeviation->Caption = "Desviacin estndar";
     MenuTSMaximumProbability->Caption = "Probabilidad mxima";
     MenuTSEnergy->Caption = "Energa";
     MenuTSContrast->Caption = "Contraste";
     MenuTSHomogeneity->Caption = "Homogeneidad";
     MenuTSEntropy->Caption = "Entropa";
     MenuTS45Degrees->Caption = "45 Grados";
     MenuTS135Degrees->Caption = "135 Grados";

     // Gradiente

     MenuGradient->Caption = "Gradiente";

     // Deteccin de contornos

     MenuEdgeDetection->Caption = "Deteccin de contornos";
     MenuEDMask2x2->Caption = "Mscaras 2x2";
     MenuEDMask3x3->Caption = "Mscaras 3x3";
     MenuEDGradient->Caption = "Gradiente";
     MenuEDLaplacian->Caption = "Laplaciana";
     MenuEDPseudoPyramid->Caption = "Pseudo-piramidal";
     MenuEDCracks->Caption = "Cracks...";
     MenuEDRange->Caption = "Rango";
     MenuEDDifference->Caption = "Diferencias";
     MenuEDHomogeneity->Caption = "Homogeneidad";
     MenuEDPhaseCongruency->Caption = "Congruencia de fase";

     // Transformadas

     MenuTransform->Caption = "Transformada";

     MenuFFT->Caption = "FFT";
     MenuFFTInversa->Caption = "FFT Inversa";
     MenuFourierLowPass->Caption = "Filtro paso bajo";
     MenuFourierHighPass->Caption = "Filtro paso alto";
     MenuFourierBandPass->Caption = "Filtro paso banda";
     MenuFourierHomomorphic->Caption = "Filtro homomrfico...";
     MenuFourierFilter->Caption = "Seccin del filtro...";
     MenuFourierLowPassExponencial->Caption = "Exponencial...";
     MenuFourierHighPassExponencial->Caption = "Exponencial...";
     MenuFourierBandPassExponencial->Caption = "Exponencial...";

     MenuHaarFilter->Caption = "Filtro...";
     MenuDaubechiesFilter->Caption = "Filtro...";
     MenuWalshFilter->Caption = "Filtro...";

     MenuHTLineDetection->Caption = "Deteccin de lneas";

     // Afilado

     MenuAfilado->Caption = "Afilado";
     MenuAfiladoUnsharpMask->Caption = "Unsharp mask...";
     MenuAfiladoLaplaciana->Caption = "Laplaciana...";
     MenuAfiladoAGC->Caption = "AGC...";

     // Suavizado

     MenuSuavizado->Caption = "Suavizado";
     MenuSuavizadoAveraging->Caption = "Media";
     MenuSuavizadoClosestAveraging->Caption = "Media 7";
     MenuSuavizadoMediana->Caption = "Mediana";
     MenuSuavizadoModa->Caption = "Moda";
     MenuSuavizadoGDA->Caption = "GDA";
     MenuSuavizadoGaussiana->Caption = "Gaussiana...";
     MenuSmoothing->Caption = "Suavizado...";

     // Ruido

     MenuRuido->Caption = "Ruido";
     MenuRuidoAditivo->Caption = "Aditivo";
     MenuRuidoMultiplicativo->Caption = "Multiplicativo";
     MenuRuidoAditivoUniforme->Caption = "Uniforme...";
     MenuRuidoAditivoNormal->Caption = "Normal...";
     MenuRuidoAditivoExponencial->Caption = "Exponencial...";
     MenuRuidoMultiplicativoUniforme->Caption = "Uniforme...";
     MenuRuidoMultiplicativoNormal->Caption = "Normal...";
     MenuRuidoMultiplicatExponencial->Caption = "Exponencial...";

  } else if (language==ENGLISH) {

     Caption = "Image processing";

     // Imagen

     MenuImagen->Caption = "&Image";
     MenuCargarImagen->Caption = "&Load...";
     MenuGuardarImagen->Caption = "&Save...";
     MenuImprimir->Caption = "&Print...";
     MenuAbout->Caption = "About...";
     MenuInformacion->Caption = "Information";
     MenuDimensiones->Caption = "Size";
     MenuHistograma->Caption = "Histogram";
     MenuHistogramaAcumulado->Caption = "Cumulative histogram";
     MenuOpciones->Caption = "&Options...";
     MenuSalir->Caption = "&Exit";

     // Edicin

     MenuEdicion->Caption = "&Edit";
     MenuDeshacer->Caption = "Undo";
     MenuRehacer->Caption = "Redo";
     MenuAcercar->Caption = "Zoom in";
     MenuAlejar->Caption = "Zoom out";
     MenuReflejoHorizontal->Caption = "Horizontal flip";
     MenuReflejoVertical->Caption = "Vertical flip";
     MenuRotacion->Caption = "Rotate...";
     MenuEscala->Caption = "Zoom...";
     MenuZoomInterpolacion->Caption = "Linear interpolation zoom";
     MenuRecorte->Caption = "Selection...";

     // Obtener

     MenuObtener->Caption = "&Obtain";
     MenuImagenNivelesDeGris->Caption = "Gray level image";
     MenuLuminanciaCIE->Caption = "Luminance (CIE)";
     MenuLuminanciaNTSC->Caption = "Luminance (NTSC)";
     MenuMediaRGB->Caption = "RGB Average";
     MenuMaximoRGB->Caption = "RGB Maximum";
     MenuMinimoRGB->Caption = "RGB Minimum";
     MenuBandaR->Caption = "R Band";
     MenuBandaG->Caption = "G Band";
     MenuBandaB->Caption = "B Band";

     // Procesamiento

     MenuProcesamiento->Caption = "&Processing";

     MenuHistogramModification->Caption = "Histogram modification";
     MenuExponencial->Caption = "Exponential";
     MenuLogaritmo->Caption = "Logarithm";
     MenuNegativar->Caption = "Negative";
     MenuAclarar->Caption = "Brightening...";
     MenuOscurecer->Caption = "Darkening...";
     MenuEcualizacion->Caption = "Equalization";
     MenuContrastar->Caption = "Contrast";
     MenuStretching->Caption = "Contrast stretching...";

     MenuConvolution->Caption = "Convolution...";
     MenuConvolution3x3->Caption = "3x3 Convolution...";

     // Morfologa

     MenuMorphology->Caption = "Morphology";
     MenuMErosion->Caption = "Erosion";
     MenuMDilation->Caption = "Dilation";
     MenuMOpen->Caption = "Opening";
     MenuMClose->Caption = "Closing";
     MenuMGradient->Caption = "Gradient";
     MenuMSmooth->Caption = "Smoothing";
     MenuMOutlining->Caption = "Outlining";

     // Segmentacin

     MenuSegmentation->Caption = "Segmentation";
     MenuThreshold->Caption = "Thresholding...";

     MenuThresholdingMethods->Caption = "Thresholding methods";
     MenuHysteresisThresholding->Caption = "Hysteresis...";
     MenuTMMean->Caption = "Mean";
     MenuTMBlackPercentage->Caption = "Black Percentage...";
     MenuTMTwoPeaks->Caption = "Two peaks";
     MenuTMLaplacian->Caption = "Laplacian...";
     MenuTMIterativeSelection->Caption = "Iterative selection";
     MenuTMFuzzyEntropy->Caption = "Fuzzy: Entropy";
     MenuTMMinimumError->Caption = "Minimum Error";
     MenuTMRelaxation->Caption = "Relaxation";

     MenuTextureSegmentation->Caption = "Texture segmentation";
     MenuTSAverage->Caption = "Average gray level";
     MenuTSStandardDeviation->Caption = "Standard deviation";
     MenuTSMaximumProbability->Caption = "Maximum probability";
     MenuTSEnergy->Caption = "Energy";
     MenuTSContrast->Caption = "Contrast";
     MenuTSHomogeneity->Caption = "Homogeneity";
     MenuTSEntropy->Caption = "Entropy";
     MenuTS45Degrees->Caption = "45 Degrees";
     MenuTS135Degrees->Caption = "135 Degrees";

     // Gradiente

     MenuGradient->Caption = "Gradient";

     // Deteccin de contornos

     MenuEdgeDetection->Caption = "Edge detection";
     MenuEDMask2x2->Caption = "2x2 Masks";
     MenuEDMask3x3->Caption = "3x3 Masks";
     MenuEDGradient->Caption = "Gradient";
     MenuEDLaplacian->Caption = "Laplacian";
     MenuEDPseudoPyramid->Caption = "Pseudo-pyramid";
     MenuEDCracks->Caption = "Cracks...";
     MenuEDRange->Caption = "Range";
     MenuEDDifference->Caption = "Difference";
     MenuEDHomogeneity->Caption = "Homogeneity";
     MenuEDPhaseCongruency->Caption = "Phase congruency";

     // Transformadas

     MenuTransform->Caption = "Transform";

     MenuFFT->Caption = "FFT";
     MenuFFTInversa->Caption = "Inverse FFT";
     MenuFourierLowPass->Caption = "Low pass filter";
     MenuFourierHighPass->Caption = "High pass filter";
     MenuFourierBandPass->Caption = "Band pass filter";
     MenuFourierHomomorphic->Caption = "Homomorphic filter...";
     MenuFourierFilter->Caption = "Cross-section filter...";
     MenuFourierLowPassExponencial->Caption = "Exponential...";
     MenuFourierHighPassExponencial->Caption = "Exponential...";
     MenuFourierBandPassExponencial->Caption = "Exponential...";

     MenuHaarFilter->Caption = "Filter...";
     MenuDaubechiesFilter->Caption = "Filter...";
     MenuWalshFilter->Caption = "Filter...";

     MenuHTLineDetection->Caption = "Line detection";

     // Afilado

     MenuAfilado->Caption = "Sharpening";
     MenuAfiladoUnsharpMask->Caption = "Unsharp mask...";
     MenuAfiladoLaplaciana->Caption = "Laplacian...";
     MenuAfiladoAGC->Caption = "AGC...";

     // Suavizado

     MenuSuavizado->Caption = "Smoothing";
     MenuSuavizadoAveraging->Caption = "Averaging";
     MenuSuavizadoClosestAveraging->Caption = "Closest averaging";
     MenuSuavizadoMediana->Caption = "Median filter";
     MenuSuavizadoModa->Caption = "Modal filter";
     MenuSuavizadoGDA->Caption = "GDA";
     MenuSuavizadoGaussiana->Caption = "Gaussian filter...";
     MenuSmoothing->Caption = "Smoothing...";

     // Ruido

     MenuRuido->Caption = "Noise";
     MenuRuidoAditivo->Caption = "Aditive";
     MenuRuidoMultiplicativo->Caption = "Multiplicative";
     MenuRuidoAditivoUniforme->Caption = "Uniform...";
     MenuRuidoAditivoNormal->Caption = "Normal...";
     MenuRuidoAditivoExponencial->Caption = "Exponential...";
     MenuRuidoMultiplicativoUniforme->Caption = "Uniform...";
     MenuRuidoMultiplicativoNormal->Caption = "Normal...";
     MenuRuidoMultiplicatExponencial->Caption = "Exponential...";
  }

  // Subforms

  FormAbout->Idioma(language);
  FormAngulo->Idioma(language);
  FormBand->Idioma(language);
  FormButterworth->Idioma(language);
  FormConvolution->Idioma(language);
  FormConvolve->Idioma(language);
  FormCutOff->Idioma(language);
  FormGauss->Idioma(language);
  FormInfo->Idioma(language);
  FormIteraciones->Idioma(language);
  FormMedia->Idioma(language);
  FormNivel->Idioma(language);
  FormPorcentaje->Idioma(language);
  FormPrint->Idioma(language);
  FormRecorte->Idioma(language);
  FormSD->Idioma(language);
  FormSection->Idioma(language);
  FormSharpen->Idioma(language);
  FormSmooth->Idioma(language);
  FormStretch->Idioma(language);
  FormWavelet->Idioma(language);
  FormZoom->Idioma(language);
}
//---------------------------------------------------------------------------
// Mens disponibles
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuImagenColor (void)
{
  MenuObtener->Visible       = true;
  MenuEdicion->Visible       = true;
  MenuProcesamiento->Visible = false;

  MenuZoomInterpolacion->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuImagenGRAYLEVEL (void)
{
  MenuObtener->Visible       = false;
  MenuEdicion->Visible       = true;
  MenuProcesamiento->Visible = true;

  MenuZoomInterpolacion->Visible = true;
}
//---------------------------------------------------------------------------
// Nueva imagen
//---------------------------------------------------------------------------
void __fastcall TFormMain::NuevaImagen (Imagen img)
{
  ImagenBMP->Nueva(img);

  if (ImagenBMP->OK()) {

     MenuGuardarImagen->Enabled = true;
     MenuImprimir->Enabled      = true;
     MenuInformacion->Enabled   = true;

     if (fft)
        MenuFFTInversa->Enabled = true;
     else
        MenuFFTInversa->Enabled = false;

     if (ImagenBMP->Color())
        MenuImagenColor();
     else
        MenuImagenGRAYLEVEL();

     if (ImagenBMP->AnteriorOK())
        MenuDeshacer->Enabled = true;
     else
        MenuDeshacer->Enabled = false;

     MenuRehacer->Enabled = false;
  }
}
//---------------------------------------------------------------------------
// Men IMAGEN
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSalirClick(TObject *Sender)
{
  Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuOpcionesClick(TObject *Sender)
{
  if (FormOptions->ShowModal()==mrOk) {
     Idioma (FormOptions->Language());
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuCargarImagenClick(TObject *Sender)
{
  int  i;
  char fichero[256];
  char extension[4];

  OpenDialog->FileName = "";

  if (OpenDialog->Execute()) {

     strcpy(fichero,OpenDialog->FileName.c_str());

     // Extensin del fichero

     for (i=0; i<3; i++)
         extension[i] = (char)toupper(fichero[strlen(fichero)-3+i]);

     extension[3] = '\0';

     // Carga la imagen

     if (!strcmp(extension,"BMP")) {

        NuevaImagen (CargaBMP(fichero));

     } else if (  !strcmp(extension,"GRG")
               || !strcmp(extension,"GRX")
               || !strcmp(extension,"GRZ") ) {

        NuevaImagen(CargaImagen(fichero));
     }

     if (!(ImagenBMP->OK()))
        Application->MessageBox ("Imagen de formato desconocido", "Error", IDOK);
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGuardarImagenClick(TObject *Sender)
{
  int  i;
  char fichero[256];
  char extension[4];

  SaveDialog->FileName = "";

  if (SaveDialog->Execute()) {

     strcpy(fichero,SaveDialog->FileName.c_str());

     // Extensin del fichero

     for (i=0; i<3; i++)
         extension[i] = (char)toupper(fichero[strlen(fichero)-3+i]);

     extension[3] = '\0';

     // Carga la imagen

     if (!strcmp(extension,"BMP")) {

        GuardaBMP(ImagenBMP->Actual,fichero);

     } else if (!strcmp(extension,"GRG")) {

        ImagenGRAYLEVEL(ImagenBMP->Actual);
        NuevaImagen(ImagenBMP->Actual);
        GuardaImagen(ImagenBMP->Actual,fichero);

     } else if (!strcmp(extension,"GRX")) {

        ImagenGRAYLEVEL(ImagenBMP->Actual);
        NuevaImagen(ImagenBMP->Actual);
        GuardaImagenGRAYLEVEL(ImagenBMP->Actual,fichero);

     } else if (!strcmp(extension,"GRZ")) {

        ImagenGRAYLEVEL(ImagenBMP->Actual);
        NuevaImagen(ImagenBMP->Actual);
        GuardaImagenBW(ImagenBMP->Actual,fichero);

     } else {

        Application->MessageBox ("Extensin no permitida", "Error", IDOK);

     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuImprimirClick(TObject *Sender)
{
  TRect Dim;
  TRect Dib;

  FormPrint->BitMap (ImagenBMP->Bitmap());

  if (FormPrint->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     Printer()->BeginDoc(); // Comenzar impresin

     Dim = Printer()->Canvas->ClipRect;

     Dib.Top    = (Dim.Bottom - Dim.Top - FormPrint->Altura) / 2;
     Dib.Bottom = Dib.Top + FormPrint->Altura;
     Dib.Left   = (Dim.Right - Dim.Left - FormPrint->Anchura) / 2;
     Dib.Right  = Dib.Left + FormPrint->Anchura;

     Printer()->Canvas->StretchDraw (Dib,ImagenBMP->Bitmap()); // Dibujar imagen
     Printer()->EndDoc(); // Finalizar impresin
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAboutClick(TObject *Sender)
{
  Hide();
  FormAbout->ShowModal();
  Show();
}
//---------------------------------------------------------------------------
// Men EDICIN
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuDeshacerClick(TObject *Sender)
{
  if (ImagenBMP->AnteriorOK()) {
     ImagenBMP->Previa();
     MenuDeshacer->Enabled = false;
     MenuRehacer->Enabled  = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRehacerClick(TObject *Sender)
{
  if (ImagenBMP->AnteriorOK()) {
     ImagenBMP->Siguiente();
     MenuDeshacer->Enabled = true;
     MenuRehacer->Enabled  = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAcercarClick(TObject *Sender)
{
  if (ImagenBMP->zoom<4) {
     ImagenBMP->Acercar();

     if (ImagenBMP->zoom==4)
        MenuAcercar->Enabled = false;

     MenuAlejar->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAlejarClick(TObject *Sender)
{
  if (ImagenBMP->zoom>-4) {
     ImagenBMP->Alejar();

     if (ImagenBMP->zoom==-4)
        MenuAlejar->Enabled = false;

     MenuAcercar->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuReflejoHorizontalClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(ReflejoHorizontal(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuReflejoVerticalClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(ReflejoVertical(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRotacionClick(TObject *Sender)
{
  if (FormAngulo->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(Rotacion(ImagenBMP->Actual,FormAngulo->Angulo));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEscalaClick(TObject *Sender)
{
  FormZoom->BitMap (ImagenBMP->Bitmap());

  if (FormZoom->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(ZoomImagen(ImagenBMP->Actual,(WORD)FormZoom->Anchura,(WORD)FormZoom->Altura));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuZoomInterpolacionClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(ZoomInterpolacion(ImagenBMP->Actual,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRecorteClick(TObject *Sender)
{
  FormRecorte->BitMap (ImagenBMP->Bitmap());

  if (FormRecorte->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen ( SubImagen (ImagenBMP->Actual,
                              (WORD)FormRecorte->X1,
                              (WORD)FormRecorte->Y1,
                              (WORD)FormRecorte->X2,
                              (WORD)FormRecorte->Y2 ));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Men OBTENER: Imagen en color ---> Imagen en niveles de gris
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuImagenNivelesDeGrisClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenGRAYLEVEL(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuLuminanciaCIEClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenLuminanciaCIE(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuLuminanciaNTSCClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenLuminanciaNTSC(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMediaRGBClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenGRAYLEVELMedia(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMaximoRGBClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenGRAYLEVELMax(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMinimoRGBClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenGRAYLEVELMin(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuBandaRClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenBandaR(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuBandaGClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenBandaG(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuBandaBClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  ImagenBandaB(ImagenBMP->Actual);
  NuevaImagen(ImagenBMP->Actual);
  MenuImagenGRAYLEVEL();
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
// Informacin de la imagen
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuDimensionesClick(TObject *Sender)
{
  FormInfo->BitMap(ImagenBMP->Bitmap());
  FormInfo->Show();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHistogramaClick(TObject *Sender)
{
  FormHistograma->Histograma (ImagenBMP->Actual);
  FormHistograma->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHistogramaAcumuladoClick(TObject *Sender)
{
  FormHistograma->HistogramaAcumulado (ImagenBMP->Actual);
  FormHistograma->ShowModal();
}
//---------------------------------------------------------------------------
// Procesamiento de imgenes en niveles de gris
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEcualizacionClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Equalization(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuContrastarClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Contrastar(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuStretchingClick(TObject *Sender)
{
  if (FormStretch->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(Stretch(ImagenBMP->Actual,
                         (BYTE)FormStretch->X,
                         (BYTE)FormStretch->Y,
                         (BYTE)FormStretch->U,
                         (BYTE)FormStretch->V ));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuNegativarClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Negativar(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAclararClick(TObject *Sender)
{
  FormNivel->Gris = 8;

  if (FormNivel->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(Aclarar(ImagenBMP->Actual,FormNivel->Gris));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuOscurecerClick(TObject *Sender)
{
  FormNivel->Gris = 8;

  if (FormNivel->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(Oscurecer(ImagenBMP->Actual,FormNivel->Gris));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Thresholding
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuThresholdClick(TObject *Sender)
{
  FormNivel->Gris = 128;

  if (FormNivel->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(Thresholding(ImagenBMP->Actual,FormNivel->Gris,0,255));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHysteresisThresholdingClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Hysteresis(ImagenBMP->Actual,0,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMSplitClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Split(ImagenBMP->Actual,0,255));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMMeanClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(MeanThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMBlackPercentageClick(TObject *Sender)
{
  FormPorcentaje->P = 0.75;

  if (FormPorcentaje->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(BlackPercentageThresholding(ImagenBMP->Actual,100*FormPorcentaje->P));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMTwoPeaksClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(TwoPeaksThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMLaplacianClick(TObject *Sender)
{
  FormPorcentaje->P = 0.85;

  if (FormPorcentaje->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(LaplacianThresholding(ImagenBMP->Actual,100*FormPorcentaje->P));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMIterativeSelectionClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(IterativeSelectionThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuOtsuClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(OtsuThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMPunClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(PunThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMKapurClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(KapurThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMJohannsenClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(JohannsenThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMFuzzyEntropyClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(FuzzyThresholding(ImagenBMP->Actual,FUZZY_ENTROPY));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMFuzzyYagerClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(FuzzyThresholding(ImagenBMP->Actual,FUZZY_YAGER));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMMinimumErrorClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(MinimumErrorThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMRelaxationClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(RelaxationThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTMDigitalDeskClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(DigitalDeskThresholding(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
// Texture segmentation
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSHorizontalClick(TObject *Sender)
{
  MenuTSHorizontal->Checked = true;
  MenuTS45Degrees->Checked  = false;
  MenuTSVertical->Checked   = false;
  MenuTS135Degrees->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTS45DegreesClick(TObject *Sender)
{
  MenuTSHorizontal->Checked = false;
  MenuTS45Degrees->Checked  = true;
  MenuTSVertical->Checked   = false;
  MenuTS135Degrees->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSVerticalClick(TObject *Sender)
{
  MenuTSHorizontal->Checked = false;
  MenuTS45Degrees->Checked  = false;
  MenuTSVertical->Checked   = true;
  MenuTS135Degrees->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTS135DegreesClick(TObject *Sender)
{
  MenuTSHorizontal->Checked = false;
  MenuTS45Degrees->Checked  = false;
  MenuTSVertical->Checked   = false;
  MenuTS135Degrees->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSAverageClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_AVERAGE_GREY_LEVEL,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSStandardDeviationClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_STANDARD_DEVIATION,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSMaximumProbabilityClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_MAXIMUM_PROBABILITY,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSEnergyClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_ENERGY,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSContrastClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_CONTRAST,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSHomogeneityClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_HOMOGENEITY,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuTSEntropyClick(TObject *Sender)
{
  int dir;

  if (MenuTSHorizontal->Checked)
     dir = DIR_HORIZONTAL;
  else if (MenuTS45Degrees->Checked)
     dir = DIR_45;
  else if (MenuTSVertical->Checked)
     dir = DIR_VERTICAL;
  else if (MenuTS135Degrees->Checked)
     dir = DIR_135;

  Screen->Cursor = crHourGlass;
  NuevaImagen(TextureSegmentation(ImagenBMP->Actual,TEXTURE_ENTROPY,6,dir,1));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
// Imagen en niveles de gris
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuLogaritmoClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(LogImagen(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuExponencialClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(ExpImagen(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Detecccin de contornos
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDMask2x2Click(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(MaskEdgeDetector2x2(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuED3x3SimpleClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(MaskEdgeDetector3x3(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuED3x3PhillipsClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(PhillipsMaskEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuED3x3FalerClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(FalerMaskEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuED3x3SobelClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(SobelEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuED3x3KirschClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(KirschEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuED3x3PrewittClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(PrewittEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDGradienteIClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Gradient1EdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDGradienteIIClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Gradient2EdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDGradienteIIIClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Gradient3EdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDLaplacianaIClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Laplacian1EdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDLaplacianaIIClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Laplacian2EdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDLaplacianaIIIClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(Laplacian3EdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDPseudoPyramidClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(PseudoPyramidEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDCracksClick(TObject *Sender)
{
  if (FormIteraciones->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(CrackEdgeDetector(ImagenBMP->Actual,FormIteraciones->N));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDRangeClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(RangeEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDDifferenceClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(DifferenceEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDHomogeneityClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(HomogeneityEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDMarrHildrethClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(MarrHildreth(ImagenBMP->Actual,FormGauss->S));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDCannyClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(CannyEdgeDetector(ImagenBMP->Actual,1,0,FormGauss->S));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDShenCastanClick(TObject *Sender)
{
  FormSmooth->S = 0.85;

  if (FormSmooth->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(ShenCastanEdgeDetector(ImagenBMP->Actual,0.95,FormSmooth->S,7,1,1));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuEDPhaseCongruencyClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen(PhaseCongruencyEdgeDetector(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
// Convolucin 3x3
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuConvolution3x3Click(TObject *Sender)
{
  if (FormConvolution->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(Convolution(ImagenBMP->Actual,
                             FormConvolution->Mask,
                             (BYTE)FormConvolution->Divisor));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Morfologa
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMSESimpleClick(TObject *Sender)
{
  MenuMSESimple->Checked     = true;
  MenuMSEMexicanHat->Checked = false;
  MenuMSESoft->Checked       = false;
  MenuMSESphere5->Checked    = false;
  MenuMSESphere7->Checked    = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMSEMexicanHatClick(TObject *Sender)
{
  MenuMSESimple->Checked     = false;
  MenuMSEMexicanHat->Checked = true;
  MenuMSESoft->Checked       = false;
  MenuMSESphere5->Checked    = false;
  MenuMSESphere7->Checked    = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMSESoftClick(TObject *Sender)
{
  MenuMSESimple->Checked     = false;
  MenuMSEMexicanHat->Checked = false;
  MenuMSESoft->Checked       = true;
  MenuMSESphere5->Checked    = false;
  MenuMSESphere7->Checked    = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMSESphere5Click(TObject *Sender)
{
  MenuMSESimple->Checked     = false;
  MenuMSEMexicanHat->Checked = false;
  MenuMSESoft->Checked       = false;
  MenuMSESphere5->Checked    = true;
  MenuMSESphere7->Checked    = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMSESphere7Click(TObject *Sender)
{
  MenuMSESimple->Checked     = false;
  MenuMSEMexicanHat->Checked = false;
  MenuMSESoft->Checked       = false;
  MenuMSESphere5->Checked    = false;
  MenuMSESphere7->Checked    = true;
}
//---------------------------------------------------------------------------
Imagen __fastcall TFormMain::SE (void)
{
  if (MenuMSESimple->Checked)
     return SE_3x3_Simple (1);
  else if (MenuMSEMexicanHat->Checked)
     return SE_3x3_MexicanHat ();
  else if (MenuMSESoft->Checked)
     return SE_3x3_Soft ();
  else if (MenuMSESphere5->Checked)
     return SE_Sphere (2);
  else if (MenuMSESphere7->Checked)
     return SE_Sphere (3);
  else
     return NULL;
}
//---------------------------------------------------------------------------
int __fastcall TFormMain::SE_OrigenX (void)
{
  if (MenuMSESimple->Checked)
     return 1;
  else if (MenuMSEMexicanHat->Checked)
     return 1;
  else if (MenuMSESoft->Checked)
     return 1;
  else if (MenuMSESphere5->Checked)
     return 2;
  else if (MenuMSESphere7->Checked)
     return 3;
  else
     return 0;
}
//---------------------------------------------------------------------------
int __fastcall TFormMain::SE_OrigenY (void)
{
  if (MenuMSESimple->Checked)
     return 1;
  else if (MenuMSEMexicanHat->Checked)
     return 1;
  else if (MenuMSESoft->Checked)
     return 1;
  else if (MenuMSESphere5->Checked)
     return 2;
  else if (MenuMSESphere7->Checked)
     return 3;
  else
     return 0;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMErosionClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Erosion(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMDilationClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Dilation(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMOpenClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Opening(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMCloseClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Closing(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMGradientClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMSmoothClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( MorphologicalSmooth(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMInteriorOutliningClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( InteriorOutlining(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuMExteriorOutliningClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( ExteriorOutlining(ImagenBMP->Actual,SE(),SE_OrigenX(),SE_OrigenY()));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
// Afilado
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAfiladoUnsharpMaskClick(TObject *Sender)
{
  FormSharpen->S = 0.30;
  FormSmooth->S  = 0.30;

  if (FormSharpen->ShowModal()==mrOk) {
     if (FormSmooth->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen( UnsharpMask(ImagenBMP->Actual,FormSmooth->S,FormSharpen->S));
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAfiladoLaplacianaClick(TObject *Sender)
{
  FormSharpen->S = 0.30;

  if (FormSharpen->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( AfiladoLaplaciana(ImagenBMP->Actual,FormSharpen->S));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuAfiladoAGCClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( AfiladoDV(ImagenBMP->Actual,3,0.03));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
// Suavizado
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSuavizadoAveragingClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( AveragingFilter(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSuavizadoClosestAveragingClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( ClosestAveragingFilter(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSuavizadoMedianaClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( MedianFilter(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSuavizadoModaClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( ModalFilter(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSuavizadoGDAClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( GDA(ImagenBMP->Actual,64,64));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSuavizadoGaussianaClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( GaussianFilter(ImagenBMP->Actual,FormGauss->S,FormGauss->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuSmoothingClick(TObject *Sender)
{
  FormSmooth->S = 0.30;

  if (FormSmooth->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( Suavizado(ImagenBMP->Actual,FormSmooth->S));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Transformada de Fourier
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFFTClick(TObject *Sender)
{
  Imagen aux;

  Screen->Cursor = crHourGlass;

  fftAnchura = ANCHURA(ImagenBMP->Actual);
  fftAltura  = ALTURA (ImagenBMP->Actual);

  aux = AdaptarImagenFFT (ImagenBMP->Actual,0);

  if (fft)
     DestruyeComplexImg(&fft);

  fft = OriginCenteredFFTImagen (aux);

  NuevaImagen( ImagenLogComplex (fft, fft->anchura, fft->altura) );

  DestruyeImagen (&aux);

  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFFTInversaClick(TObject *Sender)
{
  ComplexImg cim;
  Imagen     tmp;

  Screen->Cursor = crHourGlass;

  cim = InverseFFTImagen (fft);

  NuevaImagen( ImagenComplex ( cim, fftAnchura, fftAltura) );

  DestruyeComplexImg(&cim);

  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierLowPassIdealClick(TObject *Sender)
{
  if (FormCutOff->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( LowPassFilter(ImagenBMP->Actual,FormCutOff->Freq));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierLowPassButterworthClick(TObject *Sender)
{
  if (FormButterworth->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( ButterworthLowPass(ImagenBMP->Actual,FormButterworth->D,FormButterworth->N));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierLowPassExponencialClick(TObject *Sender)
{
  if (FormCutOff->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( ExponentialLowPass(ImagenBMP->Actual,FormCutOff->Freq));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierHighPassIdealClick(TObject *Sender)
{
  if (FormCutOff->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( HighPassFilter(ImagenBMP->Actual,FormCutOff->Freq));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierHighPassButterworthClick(TObject *Sender)
{
  if (FormButterworth->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( ButterworthHighPass(ImagenBMP->Actual,FormButterworth->D,FormButterworth->N));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierHighPassExponencialClick(TObject *Sender)
{
  if (FormCutOff->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( ExponentialHighPass(ImagenBMP->Actual,FormCutOff->Freq));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierBandPassIdealClick(TObject *Sender)
{
  if (FormBand->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( BandPassFilter(ImagenBMP->Actual,FormBand->Freq1,FormBand->Freq2));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierBandPassExponencialClick(TObject *Sender)
{
  if (FormBand->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( ExponentialBandPass(ImagenBMP->Actual,FormBand->Freq1,FormBand->Freq2));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierFilterClick(TObject *Sender)
{
  if (FormSection->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( CrossSectionFilter(ImagenBMP->Actual,FormSection->Section,FormSection->N));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuFourierHomomorphicClick(TObject *Sender)
{
  if (FormSection->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( HomomorphicFilter(ImagenBMP->Actual,FormSection->Section,FormSection->N));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Transformada de Haar
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHaarWaveletClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( ImagenHaar(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHaarFilterClick(TObject *Sender)
{
  if (FormWavelet->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( FiltradoHaar(ImagenBMP->Actual,FormWavelet->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Transformada de Daubechies
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuDaubechiesWaveletClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( ImagenDaubechies(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuDaubechiesFilterClick(TObject *Sender)
{
  if (FormWavelet->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( FiltradoDaubechies(ImagenBMP->Actual,FormWavelet->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Transformada de Walsh
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuWalshWaveletClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( ImagenWalsh(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuWalshFilterClick(TObject *Sender)
{
  if (FormWavelet->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen( FiltradoWalsh(ImagenBMP->Actual,FormWavelet->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Estimaciones del gradiente
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient1SQRTClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient1SQRT(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient1ABSClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient1ABS(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient1XClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient1X(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient1YClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient1Y(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient2SQRTClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient2SQRT(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient2ABSClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient2ABS(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient2XClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient2X(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient2YClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( Gradient2Y(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient3SQRTClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( GradientRobertsSQRT(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient3ABSClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( GradientRobertsABS(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient3XClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( GradientRobertsX(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient3YClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen( GradientRobertsY(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient4SQRTClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(GradientDoGSQRT(ImagenBMP->Actual,FormGauss->S,FormGauss->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient4ABSClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(GradientDoGABS(ImagenBMP->Actual,FormGauss->S,FormGauss->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient4XClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(GradientDoGX(ImagenBMP->Actual,FormGauss->S,FormGauss->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuGradient4YClick(TObject *Sender)
{
  if (FormGauss->ShowModal()==mrOk) {
     Screen->Cursor = crHourGlass;
     NuevaImagen(GradientDoGY(ImagenBMP->Actual,FormGauss->S,FormGauss->D));
     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Introduccin de ruido
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRuidoAditivoUniformeClick(TObject *Sender)
{
  FormPorcentaje->P = 0.1;
  FormNivel->Gris   = 32;

  if (FormPorcentaje->ShowModal()==mrOk) {
     if (FormNivel->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen(RuidoAditivoUniforme(ImagenBMP->Actual,FormPorcentaje->P,FormNivel->Gris));
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRuidoMultiplicativoUniformeClick(TObject *Sender)
{
  FormPorcentaje->P = 0.1;
  FormNivel->Gris   = 2;

  if (FormPorcentaje->ShowModal()==mrOk) {
     if (FormNivel->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen(RuidoMultiplicativoUniforme(ImagenBMP->Actual,FormPorcentaje->P,FormNivel->Gris));
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRuidoAditivoNormalClick(TObject *Sender)
{
  FormPorcentaje->P = 0.1;
  FormSD->SD        = 16;

  if (FormPorcentaje->ShowModal()==mrOk) {
     if (FormSD->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen(RuidoAditivoNormal(ImagenBMP->Actual,
                                       FormPorcentaje->P,
                                       0.0, // Media
                                       FormSD->SD));
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRuidoMultiplicativoNormalClick(TObject *Sender)
{
  FormPorcentaje->P = 0.1;
  FormSD->SD        = 1;

  if (FormPorcentaje->ShowModal()==mrOk) {
     if (FormSD->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen(RuidoMultiplicativoNormal ( ImagenBMP->Actual,
                                                FormPorcentaje->P,
                                                1.0, // Media
                                                FormSD->SD) );
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRuidoAditivoExponencialClick(TObject *Sender)
{
  FormPorcentaje->P = 0.1;
  FormMedia->AVG    = 16;

  if (FormPorcentaje->ShowModal()==mrOk) {
     if (FormMedia->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen(RuidoAditivoExponencial(ImagenBMP->Actual,
                                            FormPorcentaje->P,
                                            FormMedia->AVG));
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuRuidoMultiplicatExponencialClick(TObject *Sender)
{
  FormPorcentaje->P = 0.1;
  FormMedia->AVG    = 1;

  if (FormPorcentaje->ShowModal()==mrOk) {
     if (FormMedia->ShowModal()==mrOk) {
        Screen->Cursor = crHourGlass;
        NuevaImagen(RuidoMultiplicativoExponencial(ImagenBMP->Actual,
                                                   FormPorcentaje->P,
                                                   FormMedia->AVG));
        Screen->Cursor = crDefault;
     }
  }
}
//---------------------------------------------------------------------------
// Convolucin
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuConvolutionClick(TObject *Sender)
{
  if (FormConvolve->ShowModal()==mrOk) {

     Screen->Cursor = crHourGlass;

     if (FormConvolve->Tipo==1) {

        // Convolucin en el dominio espacial

        NuevaImagen ( ConvolveTotal ( ImagenBMP->Actual,
                                      FormConvolve->Mask,
                                      FormConvolve->DimX,
                                      FormConvolve->DimY,
                                      FormConvolve->CentroX,
                                      FormConvolve->CentroY ) );

     } else {

        // Convolucin en el dominio frecuencial

        NuevaImagen ( FourierConvolve ( ImagenBMP->Actual,
                                        FormConvolve->Mask,
                                        FormConvolve->DimX,
                                        FormConvolve->DimY,
                                        FormConvolve->CentroX,
                                        FormConvolve->CentroY ) );

     }

     Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
// Transformada de Hough
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHTLineClick(TObject *Sender)
{
  FloatImg aux;

  Screen->Cursor = crHourGlass;

  aux = HoughTransform (ImagenBMP->Actual);
  NuevaImagen (ImagenFloat(aux));
  DestruyeFloatImg(&aux);

  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::MenuHTLineDetectionClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;
  NuevaImagen (HoughLineDetection(ImagenBMP->Actual));
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
