//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <vcl\printers.hpp>

#include "PRINT.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormPrint *FormPrint;
//---------------------------------------------------------------------------
__fastcall TFormPrint::TFormPrint(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Idioma
//---------------------------------------------------------------------------
#define SPANISH 0
#define ENGLISH 1

void __fastcall TFormPrint::Idioma (int language)
{
  if (language==SPANISH) {
     Caption = "Impresin";
     LabelW->Caption = "Anchura";
     LabelH->Caption = "Altura";
     LabelP1->Caption = "pxeles";
     LabelP2->Caption = "pxeles";
     CheckBoxProporciones->Caption = "Respetar proporciones";
     BitBtnCancel->Caption = "Cancelar";
     ButtonPrinter->Caption = "Configurar impresora...";
  } else if (language==ENGLISH) {
     Caption = "Print";
     LabelW->Caption = "Width";
     LabelH->Caption = "Height";
     LabelP1->Caption = "pixels";
     LabelP2->Caption = "pixels";
     CheckBoxProporciones->Caption = "Mantain proportions";
     BitBtnCancel->Caption = "Cancel";
     ButtonPrinter->Caption = "Printer setup...";
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::ActualizarVisor (void)
{
  float Xratio, Yratio;
  char  aux[10];

  itoa ( Anchura, aux, 10);
  EditAnchura->Text = aux;
  itoa ( Altura,  aux,  10);
  EditAltura->Text = aux;

  Xratio = (float)Anchura / (float)AnchuraPRN;
  Yratio = (float)Altura / (float)AlturaPRN;

  BMP->Width  = Papel->Width  * Xratio;
  BMP->Height = Papel->Height * Yratio;
  BMP->Top    = Papel->Top  + ( (Papel->Height-BMP->Height) / 2);
  BMP->Left   = Papel->Left + ( (Papel->Width-BMP->Width) / 2);

  BMP->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::ActualizarPapel (void)
{
  float    ratio;

  AnchuraPRN = Printer()->PageWidth;
  AlturaPRN  = Printer()->PageHeight;

  if ( AlturaPRN>AnchuraPRN ) {
     Papel->Height = 128;
     ratio         = (float)AnchuraPRN/(float)AlturaPRN;
     Papel->Width  = 128 * ratio;
     Papel->Top    = 64;
     Papel->Left   = 43 + (128 - Papel->Width ) / 2;
  } else {
     Papel->Width  = 128;
     ratio         = (float)AlturaPRN/(float)AnchuraPRN;
     Papel->Height = 128 * ratio;
     Papel->Top    = 64 + (128 - Papel->Height ) / 2;
     Papel->Left   = 43;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::BitMap (Graphics::TBitmap *imagen)
{
  Anchura = imagen->Width;
  Altura  = imagen->Height;

  BMP->Picture->Bitmap = imagen;

  ActualizarPapel();
  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::CheckBoxProporcionesClick(TObject *Sender)
{
  float ratio;
  int   aux;

  if (CheckBoxProporciones->Checked) {
     ratio  = (float)BMP->Picture->Bitmap->Height / (float)BMP->Picture->Bitmap->Width;
     aux    = ratio * Anchura;

     if (aux<=AlturaPRN) {
        Altura  = aux;
     } else {
        Anchura = BMP->Picture->Bitmap->Width;
        Altura  = BMP->Picture->Bitmap->Height;
     }
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::EditAnchuraExit(TObject *Sender)
{
  float ratio;
  int   valor,aux;

  valor = atoi (EditAnchura->Text.c_str());

  if (valor!=Anchura && valor>0 && valor<=AnchuraPRN) {

     if (CheckBoxProporciones->Checked) {
        ratio = (float)BMP->Picture->Bitmap->Height / (float)BMP->Picture->Bitmap->Width;
        aux   = ratio * valor;
     } else
        aux   = Altura;

     if (aux>0 && aux<=AlturaPRN) {
        Anchura = valor;
        Altura  = aux;
     }
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::EditAlturaExit(TObject *Sender)
{
  float ratio;
  int   valor,aux;

  valor = atoi (EditAltura->Text.c_str());

  if (valor!=Altura && valor>0 && valor<=AlturaPRN) {

     if (CheckBoxProporciones->Checked) {
        ratio = (float)BMP->Picture->Bitmap->Width / (float)BMP->Picture->Bitmap->Height;
        aux   = ratio * valor;
     } else
        aux   = Anchura;

     if (aux>0 && aux<=AnchuraPRN) {
        Anchura = aux;
        Altura  = valor;
     }
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormPrint::ButtonPrinterClick(TObject *Sender)
{
  PrinterSetupDialog->Execute();

  ActualizarPapel();

  if (Anchura>AnchuraPRN || Altura>AlturaPRN) {
     Anchura = BMP->Picture->Bitmap->Width;
     Altura  = BMP->Picture->Bitmap->Height;
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
