//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RECORTE.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormRecorte *FormRecorte;
//---------------------------------------------------------------------------
__fastcall TFormRecorte::TFormRecorte(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Idioma
//---------------------------------------------------------------------------
#define SPANISH 0
#define ENGLISH 1

void __fastcall TFormRecorte::Idioma (int language)
{
  if (language==SPANISH) {
     Caption = "Recorte";
     BitBtnCancel->Caption = "Cancelar";
  } else if (language==ENGLISH) {
     Caption = "Selection";
     BitBtnCancel->Caption = "Cancel";
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormRecorte::ActualizarVisor (void)
{
  ShapeRecorte->Top    = BMP->Top    + (BMP->Height*Y1)/Altura;
  ShapeRecorte->Left   = BMP->Left   + (BMP->Width*X1)/Anchura;
  ShapeRecorte->Width  = BMP->Width  - (BMP->Width*(Anchura-(X2-X1+1)))/Anchura;
  ShapeRecorte->Height = BMP->Height - (BMP->Height*(Altura-(Y2-Y1+1)))/Altura;

  BMP->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TFormRecorte::BitMap (Graphics::TBitmap *img)
{
  char  s[10];
  float ratio;

  BMP->Picture->Bitmap = img;

  Anchura = img->Width;
  Altura  = img->Height;

  if (Altura>Anchura) {
     BMP->Height = 128;
     ratio       = (float)Anchura / (float)Altura;
     BMP->Width  = 128 * ratio;
     BMP->Top    = 64;
     BMP->Left   = 43 + (128 - BMP->Width ) / 2;
  } else {
     BMP->Width  = 128;
     ratio       = (float)Altura / (float)Anchura;
     BMP->Height = 128 * ratio;
     BMP->Top    = 64 + (128 - BMP->Height ) / 2;
     BMP->Left   = 43;
  }

  X1 = 0;
  Y1 = 0;
  X2 = Anchura-1;
  Y2 = Altura-1;

  itoa (X1, s, 10 );
  EditX1->Text = s;
  itoa (X2, s, 10 );
  EditX2->Text = s;
  itoa (Y1, s, 10 );
  EditY1->Text = s;
  itoa (Y2, s, 10 );
  EditY2->Text = s;

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormRecorte::EditX1Exit(TObject *Sender)
{
  char s[10];
  int  valor = atoi(EditX1->Text.c_str());

  if (valor>=0 && valor<X2) {
     X1 = valor;
  } else {
     itoa (X1, s, 10 );
     EditX1->Text = s;
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormRecorte::EditX2Exit(TObject *Sender)
{
  char s[10];
  int  valor = atoi(EditX2->Text.c_str());

  if (valor>X1 && valor<Anchura) {
     X2 = valor;
  } else {
     itoa (X2, s, 10 );
     EditX2->Text = s;
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormRecorte::EditY1Exit(TObject *Sender)
{
  char s[10];
  int  valor = atoi(EditY1->Text.c_str());

  if (valor>=0 && valor<Y2) {
     Y1 = valor;
  } else {
     itoa (Y1, s, 10 );
     EditY1->Text = s;
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormRecorte::EditY2Exit(TObject *Sender)
{
  char s[10];
  int  valor = atoi(EditY2->Text.c_str());

  if (valor>Y1 && valor<Altura) {
     Y2 = valor;
  } else {
     itoa (Y2, s, 10 );
     EditY2->Text = s;
  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
