//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ZOOM.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormZoom *FormZoom;
//---------------------------------------------------------------------------
__fastcall TFormZoom::TFormZoom(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Idioma
//---------------------------------------------------------------------------
#define SPANISH 0
#define ENGLISH 1

void __fastcall TFormZoom::Idioma (int language)
{
  if (language==SPANISH) {
     Caption = "Nuevas dimensiones";
     LabelW->Caption = "Anchura";
     LabelH->Caption = "Altura";
     CheckBoxProporciones->Caption = "Respetar proporciones";
     ButtonCancel->Caption = "Cancelar";
  } else if (language==ENGLISH) {
     Caption = "Zoom";
     LabelW->Caption = "Width";
     LabelH->Caption = "Height";
     CheckBoxProporciones->Caption = "Mantain proportions";
     ButtonCancel->Caption = "Cancel";
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormZoom::ActualizarVisor (void)
{
  float ratio;

  if (Altura>Anchura) {
     BMP->Height = 128;
     ratio       = (float)Anchura / (float)Altura;
     BMP->Width  = 128 * ratio;
     BMP->Top    = 64;
     BMP->Left   = 43 + (128 - BMP->Width ) / 2;
  } else {
     BMP->Width  = 128;
     ratio       = (float)Altura / (float)Anchura;
     BMP->Height = 128 * ratio;
     BMP->Top    = 64 + (128 - BMP->Height ) / 2;
     BMP->Left   = 43;
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormZoom::BitMap (Graphics::TBitmap *img)
{
  char  s[10];

  BMP->Picture->Bitmap = img;

  itoa (img->Width, s, 10 );
  EditAnchura->Text = s;
  Anchura = img->Width;

  itoa (img->Height, s, 10 );
  EditAltura->Text = s;
  Altura = img->Height;

  CheckBoxProporciones->Checked = true;

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormZoom::EditAnchuraExit(TObject *Sender)
{
  char  s[10];
  float ratio;
  int   actual = atoi(EditAnchura->Text.c_str());

  if (actual>0 && actual<=2048) {

     Anchura = actual;

     if (CheckBoxProporciones->Checked) {
        ratio  = (float)BMP->Picture->Bitmap->Height / (float)BMP->Picture->Bitmap->Width;
        Altura = ratio * Anchura;
        itoa (Altura, s, 10 );
        EditAltura->Text = s;
     }

  } else {

     itoa (Anchura, s, 10 );
     EditAnchura->Text = s;

  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormZoom::EditAlturaExit(TObject *Sender)
{
  char  s[10];
  float ratio;
  int   actual = atoi(EditAltura->Text.c_str());

  if (actual>0 && actual<2048) {

     Altura = actual;

     if (CheckBoxProporciones->Checked) {
        ratio  = (float)BMP->Picture->Bitmap->Width / (float)BMP->Picture->Bitmap->Height;
        Anchura = ratio * Altura;
        itoa (Anchura, s, 10 );
        EditAnchura->Text = s;
     }

  } else {

     itoa (Altura, s, 10 );
     EditAltura->Text = s;

  }

  ActualizarVisor();
}
//---------------------------------------------------------------------------
void __fastcall TFormZoom::CheckBoxProporcionesClick(TObject *Sender)
{
  char  s[10];
  float ratio;

  if (CheckBoxProporciones->Checked) {
     ratio  = (float)BMP->Picture->Bitmap->Height / (float)BMP->Picture->Bitmap->Width;
     Altura = ratio * Anchura;
     itoa (Altura, s, 10 );
     EditAltura->Text = s;

     ActualizarVisor();
  }
}
//---------------------------------------------------------------------------